//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package nodes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NodesGetReader is a Reader for the NodesGet structure.
type NodesGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NodesGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewNodesGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewNodesGetUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewNodesGetForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewNodesGetNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewNodesGetUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewNodesGetInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewNodesGetOK creates a NodesGetOK with default headers values
func NewNodesGetOK() *NodesGetOK {
	return &NodesGetOK{}
}

/*
NodesGetOK handles this case with default header values.

Nodes status successfully returned
*/
type NodesGetOK struct {
	Payload *models.NodesStatusResponse
}

func (o *NodesGetOK) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetOK  %+v", 200, o.Payload)
}

func (o *NodesGetOK) GetPayload() *models.NodesStatusResponse {
	return o.Payload
}

func (o *NodesGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NodesStatusResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNodesGetUnauthorized creates a NodesGetUnauthorized with default headers values
func NewNodesGetUnauthorized() *NodesGetUnauthorized {
	return &NodesGetUnauthorized{}
}

/*
NodesGetUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type NodesGetUnauthorized struct {
}

func (o *NodesGetUnauthorized) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetUnauthorized ", 401)
}

func (o *NodesGetUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewNodesGetForbidden creates a NodesGetForbidden with default headers values
func NewNodesGetForbidden() *NodesGetForbidden {
	return &NodesGetForbidden{}
}

/*
NodesGetForbidden handles this case with default header values.

Forbidden
*/
type NodesGetForbidden struct {
	Payload *models.ErrorResponse
}

func (o *NodesGetForbidden) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetForbidden  %+v", 403, o.Payload)
}

func (o *NodesGetForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NodesGetForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNodesGetNotFound creates a NodesGetNotFound with default headers values
func NewNodesGetNotFound() *NodesGetNotFound {
	return &NodesGetNotFound{}
}

/*
NodesGetNotFound handles this case with default header values.

Not Found - Backup does not exist
*/
type NodesGetNotFound struct {
	Payload *models.ErrorResponse
}

func (o *NodesGetNotFound) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetNotFound  %+v", 404, o.Payload)
}

func (o *NodesGetNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NodesGetNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNodesGetUnprocessableEntity creates a NodesGetUnprocessableEntity with default headers values
func NewNodesGetUnprocessableEntity() *NodesGetUnprocessableEntity {
	return &NodesGetUnprocessableEntity{}
}

/*
NodesGetUnprocessableEntity handles this case with default header values.

Invalid backup restoration status attempt.
*/
type NodesGetUnprocessableEntity struct {
	Payload *models.ErrorResponse
}

func (o *NodesGetUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *NodesGetUnprocessableEntity) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NodesGetUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNodesGetInternalServerError creates a NodesGetInternalServerError with default headers values
func NewNodesGetInternalServerError() *NodesGetInternalServerError {
	return &NodesGetInternalServerError{}
}

/*
NodesGetInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type NodesGetInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *NodesGetInternalServerError) Error() string {
	return fmt.Sprintf("[GET /nodes][%d] nodesGetInternalServerError  %+v", 500, o.Payload)
}

func (o *NodesGetInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NodesGetInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
